scala.tools.nsc.util

# CharArrayReader

#### abstract class CharArrayReader extends AnyRef

Self Type
  CharArrayReader

Linear Supertypes
AnyRef, Any
Known Subclasses
CharArrayLookaheadReader, ParensAnalyzer, Scanner, SourceFileScanner, UnitScanner
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. CharArrayReader
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by any2stringfmt
3. by any2ArrowAssoc
4. by any2Ensuring

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new CharArrayReader()

### Type Members

1. #### class CharArrayLookaheadReader extends CharArrayReader

### Abstract Value Members

1. #### abstract val buf: Array[Char]

2. #### abstract def error(offset: Int, msg: String): Unit

   An error routine to call on bad unicode escapes \\uxxxx.

   An error routine to call on bad unicode escapes \\uxxxx.

   Attributes
     protected

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Definition Classes
     Any

3. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

4. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from CharArrayReader to StringAdd performed by method any2stringadd in scala.Predef.
   Definition Classes
     StringAdd

5. #### def ->[B](y: B): (CharArrayReader, B)

   Implicit information
     This member is added by an implicit conversion from CharArrayReader to ArrowAssoc[CharArrayReader] performed by method any2ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

6. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

7. #### final def ==(arg0: Any): Boolean

   Definition Classes
     Any

8. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

9. #### var ch: Char

   the last read character

10. #### var charOffset: Int

    The offset one past the last read character

11. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

12. #### def decodeUni: Boolean

13. #### def ensuring(cond: (CharArrayReader) ⇒ Boolean, msg: ⇒ Any): CharArrayReader

    Implicit information
      This member is added by an implicit conversion from CharArrayReader to Ensuring[CharArrayReader] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: (CharArrayReader) ⇒ Boolean): CharArrayReader

    Implicit information
      This member is added by an implicit conversion from CharArrayReader to Ensuring[CharArrayReader] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean, msg: ⇒ Any): CharArrayReader

    Implicit information
      This member is added by an implicit conversion from CharArrayReader to Ensuring[CharArrayReader] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean): CharArrayReader

    Implicit information
      This member is added by an implicit conversion from CharArrayReader to Ensuring[CharArrayReader] performed by method any2Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

18. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

19. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

20. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from CharArrayReader to StringFormat performed by method any2stringfmt in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

21. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

22. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

23. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

24. #### def isUnicodeEscape: Boolean

    Is last character a unicode escape \\uxxxx?

25. #### var lastLineStartOffset: Int

    The start offset of the line before the current one

26. #### var lineStartOffset: Int

    The start offset of the current line

27. #### def lookaheadReader: CharArrayLookaheadReader

    A new reader that takes off at the current character position

28. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

29. #### final def nextChar(): Unit

    Advance one character; reducing CR;LF pairs to just LF

30. #### final def nextRawChar(): Unit

    Advance one character, leaving CR;LF pairs intact.

    Advance one character, leaving CR;LF pairs intact. This is for use in multi-line strings, so there are no "potential line ends" here.

31. #### final def notify(): Unit

    Definition Classes
      AnyRef

32. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

33. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

34. #### def toString(): String

    Definition Classes
      AnyRef → Any

35. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

36. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

37. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

38. #### def →[B](y: B): (CharArrayReader, B)

    Implicit information
      This member is added by an implicit conversion from CharArrayReader to ArrowAssoc[CharArrayReader] performed by method any2ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Shadowed Implicit Value Members

1. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from CharArrayReader to StringAdd performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (charArrayReader: StringAdd).self

   Definition Classes
     StringAdd

2. #### val self: Any

   Implicit information
     This member is added by an implicit conversion from CharArrayReader to StringFormat performed by method any2stringfmt in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (charArrayReader: StringFormat).self

   Definition Classes
     StringFormat

### Deprecated Value Members

1. #### def x: CharArrayReader

   Implicit information
     This member is added by an implicit conversion from CharArrayReader to ArrowAssoc[CharArrayReader] performed by method any2ArrowAssoc in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (charArrayReader: ArrowAssoc[CharArrayReader]).x

   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `leftOfArrow`instead``

2. #### def x: CharArrayReader

   Implicit information
     This member is added by an implicit conversion from CharArrayReader to Ensuring[CharArrayReader] performed by method any2Ensuring in scala.Predef.
   Shadowing
     This implicitly inherited member is ambiguous. One or more implicitly inherited members have similar signatures, so calling this member may produce an ambiguous implicit conversion compiler error.
     To access this member you can use a type ascription:

         (charArrayReader: Ensuring[CharArrayReader]).x

   Definition Classes
     Ensuring
   Annotations
     @deprecated
   Deprecated

     (Since version 2.10.0) Use `resultOfEnsuring`instead``

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from CharArrayReader to StringAdd

### Inherited by implicit conversion any2stringfmt from CharArrayReader to StringFormat

### Inherited by implicit conversion any2ArrowAssoc from CharArrayReader to ArrowAssoc[CharArrayReader]

### Inherited by implicit conversion any2Ensuring from CharArrayReader to Ensuring[CharArrayReader]

### Ungrouped